#ifndef MODULE_H
#define MODULE_H


#include <QObject>
#include "skywardhubcore.h"
#include "moduleeventshandler.h"
#include "Core/xmlobject.h"

class Module
{
public:
    Module();
    virtual ~Module();

    virtual void initialize(const XmlObject &params);
    virtual QWidget* toWidget() = 0;
    virtual XmlObject toXmlObject() = 0;
    virtual void fromXmlObject(const XmlObject &xmlObject) = 0;

    //ModulesManagerProxy& getModuleManager();
    SkywardHubCoreProxy& getCore();
    ModuleEventsHandler* getModuleEventsHandler();

protected:
    //virtual void onManagerSetted(ModulesManager *manager);

private:
    SkywardHubCoreProxy coreProxy;
    ModuleEventsHandler eventsHandler;
};
#endif // MODULE_H
