#ifndef MODULEMESSAGESBROKER_H
#define MODULEMESSAGESBROKER_H

#include <functional>
#include <QObject>
#include <QMap>
#include <QList>

#include "modulemessage.h"

class Module;

class ModuleMessagesBroker : public QObject
{
    Q_OBJECT

public:
    ModuleMessagesBroker();
    ~ModuleMessagesBroker();

    void subscribe(const QString &topic, Module *observer, std::function<void(const ModuleMessage &msg)> callBack);
    void unsubscribe(const QString &topic, Module *module);
    void publish(const QString &topic, const QString &msg);
    void publish(const ModuleMessage &msg);

    QList<QString> getSubscriptionsOf(Module *module);

public slots:
    void onModuleDeleted(Module *module);

protected:
    void send(const ModuleMessage &msg);

private:
    QMap<QString, QMap<Module*,QList<std::function<void(const ModuleMessage &msg)>>>> observers;
};

#endif // MODULEMESSAGESBROKER_H
