#ifndef SKYWARDHUBCORE_H
#define SKYWARDHUBCORE_H


#include <QObject>
#include "xmlobject.h"
#include "Modules/skywardhubstrings.h"

class ModulesManager;
class ModuleEventsHandler;
class ModuleMessagesBroker;
class Module;

class SkywardHubCore : public QObject
{
    Q_OBJECT

public:
    SkywardHubCore();
    ~SkywardHubCore();

    void init();

    ModulesManager *getModulesManager();
    ModuleEventsHandler *getModuleEventsHandler();
    ModuleMessagesBroker *getModuleMessagesBroker();

    XmlObject getSettings() const;

signals:
    void centralModuleChanged(Module *newModule);

protected:
    void checkDefaultFolders();
    void saveSettings();
    void loadFirstPage();

private:
    ModulesManager *modulesManager = nullptr;
    ModuleEventsHandler *moduleEventsHandler = nullptr;
    ModuleMessagesBroker *moduleMessagesBroker = nullptr;

    XmlObject settings;
};

// Singleton instance of SkywardHubCore

class SkywardHubCoreProxy{

public:
    static SkywardHubCore* getCore();
    SkywardHubCore* operator->()
    {
        return getCore();
    }

private:
    static SkywardHubCore *core;
};

#endif // SKYWARDHUBCORE_H
