#ifndef COMMANDPADMODULE_H
#define COMMANDPADMODULE_H

#include "Core/modulemessage.h"
#include "Modules/DefaultModule/defaultmodule.h"

namespace Ui {
class CommandPadModule;
}

class CommandPadModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit CommandPadModule(QWidget *parent = nullptr);
    ~CommandPadModule();

    QWidget* toWidget() override;
    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;

protected:
    void buildUI();
    ModuleMessage createCommandMsg(const QString &msgKey) const;
    ModuleMessage createCommandMsgWithPayload(const QString &msgKey, const QString &payload) const;
    ModuleMessage createRawEventMsg(const QString &msgKey, int event_id, int topic_id) const;
    void send(const ModuleMessage &msg);

    void onStartLogClicked();
    void onCloseLogClicked();
    void onWiggleARBServoClicked();
    void onResetARBServoClicked();
    void onWiggleDPLServoClicked();
    void onResetDPLServoClicked();
//    void onTestPrimaryCutClicked();
    void onTestModeClicked();
//    void onTestBackupCutClicked();
    void onBoardResetClicked();
    void onCalibrateALGOSClicked();
    void onCalibrateSENSORSClicked();
    void onTestAerobrakesClicked();
    void onDisableAerobrakesClicked();
    void onDeploymentAltitudeSetClicked();
    void onRefTemperatureSetClicked();
    void onRefAltitudeSetClicked();
    void onInitialCoordinatesSetClicked();
    void onAerobrakeAngleSetClicked();
    void onInitialOrientationSetClicked();
    void onArmClicked();
    void onDisarmClicked();
    void onForceLaunchClicked();
    void onForceInitClicked();
    void onNoseconeOpenClicked();
    void onEndMissionClicked();
    void onRawEventSendClicked();
    void onCutDrogueClicked();
//    void onPrimaryCutClicked();
//    void onBackupClicked();
    void onStartTelemetryClicked();
    void onStopTelemetryClicked();

private:
    Ui::CommandPadModule *ui;
};

#endif // COMMANDPADMODULE_H
