#ifndef TELEMETRYREQUESTMODULE_H
#define TELEMETRYREQUESTMODULE_H

#include <QWidget>
#include "Modules/DefaultModule/defaultmodule.h"
#include "Core/modulemessage.h"

namespace Ui {
class TelemetryRequestModule;
}

class TelemetryRequestModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit TelemetryRequestModule(QWidget *parent = nullptr);
    ~TelemetryRequestModule();

    QWidget* toWidget() override;
    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;

protected:
    void connectUI();
    void onContextMenuRequested(const QPoint &p);
    void send(const ModuleMessage &msg);
    ModuleMessage createTmMessage(const QString &msgKey);

    void on_SYS_TM_Clicked();
    void on_FMM_TM_Clicked();
    void on_LOGGER_TM_Clicked();
    void on_TMTC_TM_Clicked();
    void on_DPL_TM_Clicked();
    void on_ADA_TM_Clicked();
//    void on_CAN_TM_Clicked();
    void on_ADC_TM_Clicked();
    void on_GPS_TM_Clicked();
    void on_HR_TM_Clicked();
    void on_LR_TM_Clicked();
    void on_TEST_TM_Clicked();

    void on_PIN_OBS_TM_Clicked();
    void on_TASK_STATS_TM_Clicked();
    void on_ABK_TM_Clicked();
    void on_NAS_TM_Clicked();
    void on_MS5803_TM_Clicked();
    void on_BMX160_TM_Clicked();
    void on_LIS3MDL_TM_Clicked();
//    void on_STRAIN_BOARD_TM_Clicked();

    void on_WINDTUNNEL_TM_Clicked();
    void on_SENSORS_TM_Clicked();

private:
    Ui::TelemetryRequestModule *ui;
};

#endif // TELEMETRYREQUESTMODULE_H
