#ifndef DEFAULTMODULE_H
#define DEFAULTMODULE_H


#include <QWidget>
#include "Core/skywardhubcore.h"
#include "Core/module.h"
#include "Modules/moduleinfo.h"

class DefaultModule : public QWidget, public Module
{
public:
    DefaultModule(QWidget *parent = nullptr);
    ~DefaultModule();

    virtual void defaultContextMenuSetup();
    virtual void onSkywardHubContextMenuRequested(QMenu &menu, const QPoint &p);
    virtual void addCustomActionsToMenu();

    SkywardHubCoreProxy& getCore();
    virtual void onCustomContextMenuRequested(const QPoint &p);

    QString getName(const ModuleId id);

protected:
    void closeEvent(QCloseEvent *event) override;

    void addDefaultActionsToMenu();
    void addActionToMenu(QAction *action);


    void showMenuActionsInSeparatedMenu(const QString &menuName);
    virtual void onReplaceClicked();

private:
    SkywardHubCoreProxy proxyCore;
    QList<QAction*> menuActions;

    QString menuName;
    bool areDefaultSettingsDone = false;
};

#endif // DEFAULTMODULE_H
