#include "emptymodule.h"
#include "ui_emptymodule.h"

#include <QDebug>
#include <QAction>
#include <QPoint>
#include "Modules/Utility/contextmenuseparator.h"
#include "Core/modulesmanager.h"

EmptyModule::EmptyModule() : DefaultModule(), ui(new Ui::EmptyModule)
{
    ui->setupUi(this);
    defaultContextMenuSetup();
    connectUiSlots();
}

EmptyModule::~EmptyModule()
{
    delete ui;
    //qDebug() << "EmptyPanel >> Deleted";
}

void EmptyModule::connectUiSlots()
{
    connect(ui->selectPanel_button,&QPushButton::clicked,this,&EmptyModule::onSelectPanelClick);
}


void EmptyModule::onSelectPanelClick()
{
    //onModuleSelected(getManager()->InvokeModulesPickerService());
    onReplaceClicked();
}

//void EmptyModule::onModuleSelected(Module* modulePointer)
//{
//    emit getModuleEventsHandler()->replaceMeWith(modulePointer);
//}

QWidget *EmptyModule::toWidget()
{
    return this;
}

XmlObject EmptyModule::toXmlObject()
{
    return XmlObject(getName(ModuleId::EMPTY));
}

void EmptyModule::fromXmlObject(const XmlObject &xmlObject)
{
    Q_UNUSED(xmlObject);
}

