#ifndef FILESTREAMMODULE_H
#define FILESTREAMMODULE_H

#include <QWidget>
#include "Modules/DefaultModule/defaultmodule.h"
#include "Core/modulemessage.h"

#include <QLineEdit>
#include <QFile>

namespace Ui {
class FileStreamModule;
}

class FileStreamModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit FileStreamModule(QWidget *parent = nullptr);
    ~FileStreamModule();

    QWidget *toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;


protected:
    void connectUI();
    QString getFilePath() const;
    QString getTopicName() const;
    void resetTopicName();
    void onMsgReceived(const ModuleMessage &msg);

    void onAddTopicClicked();
    void onStartClicked();
    void onStopClicked();
    void onTopicEdit();
    void disableOnStartElement();
    void enableElementOnStop();
    void onFileChanged();
    void onShowFileClick();

    void addTopic(const QString &topic);
    QLineEdit* createTopicView(const QString &topic) const;

    void deleteAllTopicViews();

private:
    Ui::FileStreamModule *ui;

    QList<QLineEdit*> topicViewsList;
    QFile file;
};

#endif // FILESTREAMMODULE_H
