#include "skywardhubmainwindow.h"
#include "ui_skywardhubmainwindow.h"

#include <QMenu>

#include "Core/module.h"
#include "Core/modulesmanager.h"

SkywardHubMainWindow::SkywardHubMainWindow(QWidget *parent) : QMainWindow(parent), ui(new Ui::SkywardHubMainWindow)
{
    ui->setupUi(this);

    mainWindow = new Window();
    setCentralWidget(mainWindow);
    connect(core->getModulesManager(), &ModulesManager::contextMenuRequest, this, &SkywardHubMainWindow::onContextMenuRequest);
    connect(core->getModulesManager(), &ModulesManager::pageAdded, this, &SkywardHubMainWindow::onPageAdded);
    connect(core->getModulesManager(), &ModulesManager::appQuitRequested, this, &SkywardHubMainWindow::onQuitRequested);
    core->init();
}

SkywardHubMainWindow::~SkywardHubMainWindow()
{
    delete ui;
}

void SkywardHubMainWindow::onContextMenuRequest(QMenu &menu, const QPoint &p)
{
    QAction changeSettings("Edit Settings");
    menu.addAction(&changeSettings);
    connect(&changeSettings,&QAction::triggered,this,&SkywardHubMainWindow::openEditSettings);

    menu.exec(p);
}

void SkywardHubMainWindow::openEditSettings()
{

}

void SkywardHubMainWindow::onPageAdded(int index)
{
    Module* m = core->getModulesManager()->getModuleAt(index);

    if(m != nullptr){
        if(index == 0){
            mainWindow->updateModule(m);
            return;
        }
        Window *window = new Window();
        window->setWindowTitle("Window " + QString::number(index));
        window->setCentralModule(m);
        window->show();
    }
}

void SkywardHubMainWindow::onQuitRequested()
{
    QApplication::quit();
}

void SkywardHubMainWindow::closeEvent(QCloseEvent *event)
{
    core->getModulesManager()->setRebuild(false);
    QMainWindow::closeEvent(event);
}
