#ifndef SKYWARDHUBMAINWINDOW_H
#define SKYWARDHUBMAINWINDOW_H

#include <QMainWindow>
#include "Core/skywardhubcore.h"
#include "window.h"

namespace Ui {
class SkywardHubMainWindow;
}

class SkywardHubMainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit SkywardHubMainWindow(QWidget *parent = nullptr);
    ~SkywardHubMainWindow();

protected slots:
    void onPageAdded(int index);
    void onQuitRequested();
    void onContextMenuRequest(QMenu &menu, const QPoint &p);
    void openEditSettings();

protected:
    void closeEvent(QCloseEvent *event);

private:
    Ui::SkywardHubMainWindow *ui;

    SkywardHubCoreProxy core;
    Window *mainWindow = nullptr;
};

#endif // SKYWARDHUBMAINWINDOW_H
