#ifndef WINDOW_H
#define WINDOW_H

#include <QWidget>
#include <QMenu>
class Module;

namespace Ui {
class Window;
}

class Window : public QWidget
{
    Q_OBJECT

public:
    explicit Window(QWidget *parent = nullptr);
    ~Window();


    void updateModule(Module *m);
    Module *getCentralModule() const;

    void setCentralModule(Module *value);

protected:
    void closeEvent(QCloseEvent *event) override;
    void onWidgetDestroyed();
    void onReplaceRequested(Module *sender, Module *newModule);

private:
    Ui::Window *ui;

    Module *centralModule = nullptr;
};

#endif // WINDOW_H
