#ifndef MAVLINKCOMMANDADAPTER_H
#define MAVLINKCOMMANDADAPTER_H

#include <QObject>
#include "mavlinkversionheader.h"
#include "Core/modulemessage.h"
#include "mavlinkwriter.h"
#include <QSerialPort>
#include <QMap>
#include "Core/modulesmanager.h"

/*
 * This class adapt/translate the command received from the UI in mavlink_cmd that can be sent
 */
class MavlinkCommandAdapter : public QObject
{
    Q_OBJECT

public:

    MavlinkCommandAdapter();

    void send(mavlink_message_t msg);
    // void setSerialPort(QSerialPort *value);
    void setPortNumber(int port);

    mavlink_message_t encode_PING_TC();
    mavlink_message_t encode_NOARG_TC(int cmd_id);
    mavlink_message_t encode_START_LAUNCH_TC(const ModuleMessage &msg);
    mavlink_message_t encode_TELEMETRY_REQUEST_TC(uint8_t board_id);
    mavlink_message_t encode_RAW_EVENT_TC(const ModuleMessage &msg);
    mavlink_message_t encode_AEROBRAKE_ANGLE_TC(const ModuleMessage &msg);
    mavlink_message_t encode_REFERENCE_ALTITUDE_TC(const ModuleMessage &msg);
    mavlink_message_t encode_REFERENCE_TEMPERATURE_TC(const ModuleMessage &msg);
    mavlink_message_t encode_DEPLOYMENT_ALTITUDE_TC(const ModuleMessage &msg);
    mavlink_message_t encode_INITIAL_ORIENTATION_TC(const ModuleMessage &msg);
    mavlink_message_t encode_INITIAL_COORDINATES_TC(const ModuleMessage &msg);

    bool produceMsgFromXml(const XmlObject &xml, mavlink_message_t *msg);

    //void loadMsgDefinition();

    static const int MAV_CMP = 96;
    static const int MAV_SYS = 171;

signals:
    void publishRequested(const ModuleMessage &msg);

protected:
    //void parseMavTmList(const XmlObject *xml);

private:
    // QSerialPort *serial = nullptr;
    MavlinkWriter mavlinkWriter;
    QMap<QString, int> msgNameIdMap;
    //QString msgDefinitionFile = GroundStation::getResourceDirectory()+"/mavlinkMsgDefinition.xml";

    int portNumber = -1;
};

#endif // MAVLINKCOMMANDADAPTER_H
