#include "mavlinkwriter.h"

#include <chrono>
#include "rs232.h"
#include <QDebug>

MavlinkWriter::MavlinkWriter()
{

}

void MavlinkWriter::startAsyncWrite(mavlink_message_t msgToSend)
{
    this->msgToSend = msgToSend;
    this->start(); // Call run()    
}

void MavlinkWriter::writeMsg(mavlink_message_t *msgToSend)
{
    mtx.lock();
    unsigned char buff[sizeof(mavlink_message_t)+1];
    int msg_len = mavlink_msg_to_send_buffer(buff, msgToSend);
    //serial->write(reinterpret_cast<char*>(buff),msg_len);
    try {
        RS232_SendBuf(portNumber, buff, msg_len);
    }  catch (...) {
        qDebug() << "MavlinkWriter: Error, writeMsg serial port error";
    }

    mtx.unlock();
}

void MavlinkWriter::run()
{
    if(portNumber >= 0){
        try {
            writeMsg(&msgToSend);
        } catch (...) {

        }
    }
}

void MavlinkWriter::setPortNumber(int value)
{
    portNumber = value;
}
