#ifndef MAVLINKWRITER_H
#define MAVLINKWRITER_H

#include <QThread>
#include <mutex>
#include <QSerialPort>
#include "mavlinkversionheader.h"

class MavlinkWriter : public QThread
{
    Q_OBJECT

public:
    MavlinkWriter();

    void startAsyncWrite(mavlink_message_t msgToSend);

    void setPortNumber(int value);

protected:
    void writeMsg(mavlink_message_t *msgToSend);
    void run();

private:
//    QSerialPort *serial = nullptr;
    int portNumber = -1;
    mavlink_message_t msgToSend;
    std::mutex mtx;
};

#endif // MAVLINKWRITER_H
