#ifndef SCROLLAREAMODULE_H
#define SCROLLAREAMODULE_H

#include "Modules/DefaultModule/defaultmodule.h"

namespace Ui {
class ScrollAreaModule;
}

class ScrollAreaModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit ScrollAreaModule(QWidget *parent = nullptr);
    ~ScrollAreaModule();

    QWidget *toWidget() override;
    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;

protected:
    void addCustomActionsToMenu() override;
    void onAddItemClicked();

    void clearModuleList();
    void onModuleBeforeDelete(Module *module);
    void addModule(Module *module, int position = 0);
    void replace(Module *oldModule, Module *newModule);

private:
    Ui::ScrollAreaModule *ui;
    QList<Module*> modulesList;
};

#endif // SCROLLAREAMODULE_H
