#ifndef PREFABVIEWELEMENT_H
#define PREFABVIEWELEMENT_H

#include <QWidget>
#include "Core/xmlobject.h"

namespace Ui {
class PrefabViewElement;
}

class PrefabViewElement : public QWidget
{
    Q_OBJECT

public:
    explicit PrefabViewElement(const QString &name, QWidget *parent = nullptr);
    ~PrefabViewElement();

    void setName(const QString &value);
    QString getName() const;

    QString getDesctiption() const;
    void setDesctiption(const QString &value);

    QString getPathToImg() const;
    void setPathToImg(const QString &value);

    XmlObject getXml() const;
    void setXml(XmlObject &xml);

    void addActiveModuleName(const QString &moduleName);
    void removeActiveModuleName(const QString &moduleName);
    bool containsModule(const QString &moduleName);

    void setDeleteButtonVisibility(bool visibility);
    void setLaunchButtonText(const QString &txt);
    void setIconButtonVisibility(bool visibility);

    QString getFilePath() const;
    void setFilePath(const QString &value);

public slots:
    void onIconClicked();
    void onLaunchClicked();
    void onDeleteClicked();

signals:
    void selected(PrefabViewElement *prefabVElement);
    void launchRequested(PrefabViewElement *prefabVElement);
    void deleteRequested(PrefabViewElement *prefabVElement);

private:
    Ui::PrefabViewElement *ui;

    QString name;
    QString desctiption;
    QString pathToImg;
    XmlObject xml;
    QList<QString> activeModules;
    QString filePath = "";

    int height = 0;
    int width = 0;

};

#endif // PREFABVIEWELEMENT_H
