#ifndef SPLITTERMODULE_H
#define SPLITTERMODULE_H

#include <QWidget>
#include <QSplitter>

#include "Core/module.h"
#include "Modules/DefaultModule/defaultmodule.h"

namespace Ui {
class SplitterModule;
}

class SplitterModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit SplitterModule(Qt::Orientation orientation = Qt::Horizontal);
    ~SplitterModule() override;

    QWidget *toWidget() override;
    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;

    void initialize(const XmlObject &params) override;
    void addCustomActionsToMenu() override;


    void addModule(Module *module);
    void addModule(Module *module, int position);
    void replace(Module *oldModule, Module *newModule);
    void setOrientation(Qt::Orientation orientation);
    Qt::Orientation getOrientation() const;

    void swapOrientation();

protected:
    void buildUI(Qt::Orientation orientation = Qt::Horizontal);
    void onModuleDelete(Module *module);

private:
    Ui::SplitterModule *ui;
    QSplitter splitter;
    QList<Module*> childList;
};

#endif // SPLITTERMODULE_H
