#ifndef STATEVIEWERMODULE_H
#define STATEVIEWERMODULE_H

#include <QWidget>
#include <QLabel>

#include "Modules/DefaultModule/defaultmodule.h"
#include "Core/modulemessage.h"


namespace Ui {
class StateViewerModule;
}

class StateViewerModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit StateViewerModule(QWidget *parent = nullptr);
    ~StateViewerModule();

    QWidget *toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;


protected:
    void addCustomActionsToMenu() override;
    void onConfigureClicked();
    void setTopic(const QString &topic);
    void onMsgReceived(const ModuleMessage &msg);
    void setState(int state);
    void updateView(int state);
    void setStyleAfter(int threshold, const QString &style);
    void setStyleBefore(int threshold, const QString &style);

private:
    Ui::StateViewerModule *ui;
    QString inputTopic = "";

    QList<QLabel*> labels;

    int currentState = -1;
    QMap<int, int> labelsIndexes;
};

#endif // STATEVIEWERMODULE_H
