#ifndef TIMERCONTROLLERMODULE_H
#define TIMERCONTROLLERMODULE_H

#include "Modules/DefaultModule/defaultmodule.h"
#include <QTimer>
#include <QTime>



namespace Ui {
class TimerControllerModule;
}

class TimerControllerModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit TimerControllerModule(QWidget *parent = nullptr);
    ~TimerControllerModule();

    QWidget *toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;


protected:
    void onSetTimerClicked();
    void onStartTimerClicked();
    void onHoldTimerClicked();
    void onSetInfoLabelClicked();
    void onTimerTick();
    void onEnableOutputToggled(bool val);

    QString updateTimeLabel();
    void setInfoLabel(const QString &txt);
    void updateOutputFile(const QString &outputTxt) const;

    void initCurrentTime();
    QString getPrefix() const;
    bool isTimeExpired() const;
    int getIncrement() const;

private:
    Ui::TimerControllerModule *ui;
    QTimer timer;
    QString timeFormat = "hh:mm:ss";
    QTime currentTime;
    int timerIntervalMs = 1000;
    int increment = -1;
    bool isHold;
    bool isOutputEnabled = false;
    QString holdTxt = "HOLD";

    QString tMinus = "T- ";
    QString tPlus = "T+ ";
};

#endif // TIMERCONTROLLERMODULE_H
