#include "treevieweritem.h"


TreeViewerItem::TreeViewerItem() : QObject(), QTreeWidgetItem()
{

}

TreeViewerItem::TreeViewerItem(const XmlObject &xml) : TreeViewerItem()
{
    this->xml = xml;
    setText(0, xml.getObjectName());

    int count = 1;
    auto i = xml.attributesIterator();
    while(i.hasNext()){
        i.next();
        // line = line + ", " + i.value() + " ("+i.key()+")";
        setText(count, i.value());
    }
}

TreeViewerItem::~TreeViewerItem()
{

}

QList<QString> TreeViewerItem::getAttributesNameList() const
{
    QList<QString> list;
    auto i = xml.attributesIterator();
    while(i.hasNext()){
        i.next();
        list.append(i.key());
    }
    return list;
}

void TreeViewerItem::setAttributesColumn(QList<QString> headers)
{
    for(int column = 0; column < headers.count(); column++){
        if(xml.hasAttribute(headers[column])){
            setText(column, xml.getAttribute(headers[column]));
        }
    }
}
