#ifndef MODULESPICKER_H
#define MODULESPICKER_H

#include <QWidget>
#include <QSharedPointer>
#include <QPushButton>
#include <QDialog>
#include "Core/module.h"

namespace Ui {
class ModulesPicker;
}

class ModulesPicker : public QDialog
{
    Q_OBJECT

public:
    explicit ModulesPicker();
    ~ModulesPicker() override;

    void addModule(const QString &txt);
    void onModuleSelected(Module *module);
    void onModuleSelected(const QString &mName);
    Module* start();

//    QWidget* toWidget() override;
//    XmlObject toXmlObject() override;
//    void fromXmlObject(const XmlObject &xmlObject) override;

signals:
    void moduleSelected(Module* selectedModule);

protected:
    void createAndConnectUI();
    void connectSlot(QPushButton *button);
    void onCreateModuleButtonClick();
    void onSplitterButtonClick();
    QPushButton* createButton(const QString &name);

private:
    Ui::ModulesPicker *ui;
    Module** selectedModule = nullptr;
};

#endif // MODULESPICKER_H
