#ifndef SUBSCRIPTIONSPANEL_H
#define SUBSCRIPTIONSPANEL_H

#include <QWidget>
#include <QListWidgetItem>
#include <QList>

namespace Ui {
class SubscriptionsPanel;
}

class SubscriptionsPanel : public QWidget
{
    Q_OBJECT

public:
    explicit SubscriptionsPanel(const QList<QString> *subscriptionsList, QWidget *parent = nullptr);
    ~SubscriptionsPanel();

    void addSubscription(const QString &s);
    void removeSubscription(QListWidgetItem *item);

public slots:
    void onAddSubscriptionClicked();
    void onRemoveClicked();
    void onItemDoubleClick(QListWidgetItem *item);

signals:
    void SubscriptionAdded(const QString &subscription);
    void SubscriptionRemoved(const QString &subscription);

private:
    Ui::SubscriptionsPanel *ui;
};

#endif // SUBSCRIPTIONSPANEL_H


