#ifndef VALUEELEMENT_H
#define VALUEELEMENT_H

#include <QString>
#include "Core/xmlobject.h"

class ValueElement
{

public:
    ValueElement();
    ~ValueElement();
    ValueElement(const ValueElement &other);
    ValueElement(const QString &name, const QString &topic, const QString &receivedValue, const QString &displayedValue, const QString &color, const QString &outputTopic = "");

    ValueElement operator=(const ValueElement &other);
    QString getName() const;
    void setName(const QString &value);

    QString getTopic() const;
    void setTopic(const QString &value);

    QString getReceivedValue() const;
    void setReceivedValue(const QString &value);

    QString getDisplayedValue() const;
    void setDisplayedValue(const QString &value);

    QString getColor() const;
    void setColor(const QString &value);

    QString toString() const;

    XmlObject toXmlObject() const;
    bool fromXmlObject(const XmlObject &xmlObject);

    QString getCurrentValue() const;
    bool updateCurrentValue(const QString &value);

    QString getOutpuTopic() const;
    void setOutpuTopic(const QString &value);

    bool isEmitActive() const;

    bool isDisplayInView() const;
    void setDisplayInView(bool value);

protected:
    void copy(const ValueElement &other);

private:
    QString name = "";
    QString topic = "";
    QString receivedValue = "";
    QString displayedValue = "";
    QString color = "#ffffff";
    QString outpuTopic = "";
    QString currentValue = "";
    bool displayInView = true;
};

#endif // VALUEELEMENT_H
