#ifndef VALUESCONVERTERVIEWERMODULE_H
#define VALUESCONVERTERVIEWERMODULE_H

#include <QWidget>
#include <QLabel>
#include "valueelement.h"
#include "Modules/DefaultModule/defaultmodule.h"
#include "Core/modulemessage.h"

class ValuesViewerConfigPanel;


namespace Ui {
class ValuesConverterViewerModule;
}

class ValuesConverterViewerModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit ValuesConverterViewerModule(QWidget *parent = nullptr);
    ~ValuesConverterViewerModule();


    QWidget *toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;

protected:
    void onConfigureClicked();
    void onConfigurationSaved(ValuesViewerConfigPanel *sPanel);
    void addCustomActionsToMenu() override;
    QLabel* createView(const ValueElement &el) const;
    void clearLabels();
    void createLabels();
    void addRule(const ValueElement &el);
    void setRules(const QList<ValueElement> &rList);
    void onMsgReceived(const ModuleMessage &msg);
    void clearRules();
    int findLabelIndexByName(const QString &name);
    bool isTopicPresent(const QString &topic);

private:
    Ui::ValuesConverterViewerModule *ui;
    int minColNumber = 1;
    int columns = minColNumber;
    QList<QLabel*> labels;
    QList<ValueElement> rules;

};

#endif // VALUESCONVERTERVIEWERMODULE_H
