#ifndef SKYWARDHUBSTRINGS_H
#define SKYWARDHUBSTRINGS_H

#include <QString>

class SkywardHubStrings
{
public:
    SkywardHubStrings();

    static const QString defaultConfigurationFolder;
    static const QString defaultSettingsFilePath;
    static const QString defaultPrefabsFolderName;
    static const QString defaultPrefabsFolder;
    static const QString defaultConfigurationFileName;
    static const QString defaultConfigurationIconPath;
    static const QString defaultLogsFolder;
    static const QString defaultStreamFile;

    // Xml Tags Name
    static const QString settingsObjectName;
    static const QString skywardHubInitFileTag;
    static const QString configurationNameAttribute;
    static const QString configurationIconPathAttribute;
    static const QString configurationDescriptionAttribute;
    static const QString configurationNameValue;


    // Output Messages & UI text
    static const QString settingsSavedCorrectlyMsg;
    static const QString serialPortClosedErrorMsg;
    static const QString imageViewerInfo;


    // Topics
    static const QString commandsTopic;
    static const QString telemetryRequestTopic;
    static const QString treeViewerReceivingBaseTopic;

    static const QString logCommandsTopic;
    static const QString raw_event_id;
    static const QString raw_event_topic_id;
    static const QString mavlink_orientation_tc_yaw_name;
    static const QString mavlink_orientation_tc_pitch_name;
    static const QString mavlink_orientation_tc_roll_name;
    static const QString mavlink_initial_coordinates_tc_latitude_name;
    static const QString mavlink_initial_coordinates_tc_longitude_name;

    static const QString msgIdField;
    static const QString msgSequenceNumberField;

    static const QString mavlink_quality_link_topic;
    static const QString mavlink_received_msg_topic;
    static const QString mavlink_received_msg_ACK_topic;
};



#endif // SKYWARDHUBSTRINGS_H
