QT       += core gui

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets printsupport serialport

CONFIG += c++11

# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0


SOURCES += \
    Core/module.cpp \
    Core/moduleeventshandler.cpp \
    Core/modulemessage.cpp \
    Core/modulemessagesbroker.cpp \
    Core/modulesmanager.cpp \
    Core/skywardhubcore.cpp \
    Core/xmlobject.cpp \
    Modules/CommandPad/commandpadmodule.cpp \
    Modules/CommandPad/telemetryrequestmodule.cpp \
    Modules/DefaultModule/defaultmodule.cpp \
    Modules/Empty/emptymodule.cpp \
    Modules/FileStream/filestreammodule.cpp \
    Modules/Graph/graphmodule.cpp \
    Modules/Graph/qcustomplot.cpp \
    Modules/ImageViewer/customgraphicsscene.cpp \
    Modules/ImageViewer/imagevieweritem.cpp \
    Modules/ImageViewer/imageviewermodule.cpp \
    Modules/ImageViewer/imageviewersettings.cpp \
    Modules/MainWindow/skywardhubmainwindow.cpp \
    Modules/MainWindow/window.cpp \
    Modules/Mavlink/mavlinkcommandadapter.cpp \
    Modules/Mavlink/mavlinkmodule.cpp \
    Modules/Mavlink/mavlinkreader.cpp \
    Modules/Mavlink/mavlinkrocketmsgtestingmodule.cpp \
    Modules/Mavlink/mavlinkwriter.cpp \
    Modules/Mavlink/rs232.c \
    Modules/MessageViewer/messagesviewermodule.cpp \
    Modules/ScrollArea/scrollareamodule.cpp \
    Modules/SkywardHub/deployer.cpp \
    Modules/SkywardHub/deployerpathpicker.cpp \
    Modules/SkywardHub/prefabdialog.cpp \
    Modules/SkywardHub/prefabviewelement.cpp \
    Modules/SkywardHub/skywardhubmodule.cpp \
    Modules/Splitter/splittermodule.cpp \
    Modules/StateViewer/stateviewermodule.cpp \
    Modules/Table/tablemodule.cpp \
    Modules/Test/testmodule.cpp \
    Modules/TimerController/timercontrollermodule.cpp \
    Modules/TreeViewer/treevieweritem.cpp \
    Modules/TreeViewer/treeviewermodule.cpp \
    Modules/Utility/contextmenuseparator.cpp \
    Modules/Utility/modulespicker.cpp \
    Modules/Utility/saveconfigurationdialog.cpp \
    Modules/Utility/subscriptionspanel.cpp \
    Modules/Utility/togglebutton.cpp \
    Modules/ValuesConverterViewer/valueelement.cpp \
    Modules/ValuesConverterViewer/valuesconverterviewermodule.cpp \
    Modules/ValuesConverterViewer/valuesviewerconfigpanel.cpp \
    Modules/moduleinfo.cpp \
    Modules/moduleslist.cpp \
    Modules/skywardhubstrings.cpp \
    main.cpp

HEADERS += \
    Core/module.h \
    Core/moduleeventshandler.h \
    Core/modulemessage.h \
    Core/modulemessagesbroker.h \
    Core/modulesmanager.h \
    Core/skywardhubcore.h \
    Core/xmlobject.h \
    Modules/CommandPad/commandpadmodule.h \
    Modules/CommandPad/telemetryrequestmodule.h \
    Modules/DefaultModule/defaultmodule.h \
    Modules/Empty/emptymodule.h \
    Modules/FileStream/filestreammodule.h \
    Modules/Graph/graphmodule.h \
    Modules/Graph/qcustomplot.h \
    Modules/ImageViewer/customgraphicsscene.h \
    Modules/ImageViewer/imagevieweritem.h \
    Modules/ImageViewer/imageviewermodule.h \
    Modules/ImageViewer/imageviewersettings.h \
    Modules/MainWindow/skywardhubmainwindow.h \
    Modules/MainWindow/window.h \
    Modules/Mavlink/mavlinkcommandadapter.h \
    Modules/Mavlink/mavlinkmodule.h \
    Modules/Mavlink/mavlinkreader.h \
    Modules/Mavlink/mavlinkrocketmsgtestingmodule.h \
    Modules/Mavlink/mavlinkversionheader.h \
    Modules/Mavlink/mavlinkversionheader.h \
    Modules/Mavlink/mavlinkwriter.h \
    Modules/Mavlink/rs232.h \
    Modules/MessageViewer/messagesviewermodule.h \
    Modules/ScrollArea/scrollareamodule.h \
    Modules/SkywardHub/deployer.h \
    Modules/SkywardHub/deployerpathpicker.h \
    Modules/SkywardHub/prefabdialog.h \
    Modules/SkywardHub/prefabviewelement.h \
    Modules/SkywardHub/skywardhubmodule.h \
    Modules/Splitter/splittermodule.h \
    Modules/StateViewer/stateviewermodule.h \
    Modules/Table/tablemodule.h \
    Modules/Test/testmodule.h \
    Modules/TimerController/timercontrollermodule.h \
    Modules/TreeViewer/treevieweritem.h \
    Modules/TreeViewer/treeviewermodule.h \
    Modules/Utility/contextmenuseparator.h \
    Modules/Utility/modulespicker.h \
    Modules/Utility/saveconfigurationdialog.h \
    Modules/Utility/subscriptionspanel.h \
    Modules/Utility/togglebutton.h \
    Modules/ValuesConverterViewer/valueelement.h \
    Modules/ValuesConverterViewer/valuesconverterviewermodule.h \
    Modules/ValuesConverterViewer/valuesviewerconfigpanel.h \
    Modules/moduleinfo.h \
    Modules/moduleslist.h \
    Modules/skywardhubstrings.h

FORMS += \
    Modules/CommandPad/commandpadmodule.ui \
    Modules/CommandPad/telemetryrequestmodule.ui \
    Modules/Empty/emptymodule.ui \
    Modules/FileStream/filestreammodule.ui \
    Modules/Graph/graphmodule.ui \
    Modules/ImageViewer/imageviewermodule.ui \
    Modules/ImageViewer/imageviewersettings.ui \
    Modules/MainWindow/skywardhubmainwindow.ui \
    Modules/MainWindow/window.ui \
    Modules/Mavlink/mavlinkmodule.ui \
    Modules/Mavlink/mavlinkrocketmsgtestingmodule.ui \
    Modules/MessageViewer/messagesviewermodule.ui \
    Modules/ScrollArea/scrollareamodule.ui \
    Modules/SkywardHub/deployerpathpicker.ui \
    Modules/SkywardHub/prefabdialog.ui \
    Modules/SkywardHub/prefabviewelement.ui \
    Modules/SkywardHub/skywardhubmodule.ui \
    Modules/Splitter/splittermodule.ui \
    Modules/StateViewer/stateviewermodule.ui \
    Modules/Table/tablemodule.ui \
    Modules/Test/testmodule.ui \
    Modules/TimerController/timercontrollermodule.ui \
    Modules/TreeViewer/treeviewermodule.ui \
    Modules/Utility/modulespicker.ui \
    Modules/Utility/saveconfigurationdialog.ui \
    Modules/Utility/subscriptionspanel.ui \
    Modules/ValuesConverterViewer/valuesconverterviewermodule.ui \
    Modules/ValuesConverterViewer/valuesviewerconfigpanel.ui

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target
